       Identification Division.
       Program-Id.  Example-A.
      *
      * Title: EXAMPLEA.CBL: Well-Formed / Validate diagnostics.
      *
      * Copyright (c) 2008-2010, Micro Focus (IP) Ltd.
      *
      * Version Identification:
      *   $Revision: 59838 $
      *   $Date: 2010-12-21 19:33:53 +0000 (Tue, 21 Dec 2010) $
      *
       Data Division.
       Working-Storage Section.

       Copy "s-struct.cpy".

       01  Done Pic X.

       Copy "lixmlall.cpy".

       Procedure Division.
       A.
           Display "Example-A - Illustrate diagnostics for"
                   " invalid documents".
           Display " and documents that are not well-formed".

           XML INITIALIZE.
           If Not XML-OK Go to Z End-If.

           Display Space.
           Display "XML TEST WELLFORMED-FILE - not well-formed ...".

           XML TEST WELLFORMED-FILE
               "x-addressa1".     *> document to test file name (input)
           If Not XML-OK
             Perform Display-Status
             Display "  ... wellformedness test failed (as it should)."
           Else
             Display "  ... wellformedness test succeeeded (error)!"
           End-If.

           Display Space.                                               TESTS
           Display "Press a key to continue:".                          TESTS
           Accept Done.                                                 TESTS

           Display Space.
           Display
               "XML TEST WELLFORMED-FILE - well-formed & invalid ...".

           XML TEST WELLFORMED-FILE
               "x-addressa2".     *> document to test file name (input)
           If Not XML-OK Go to Z End-If.

           Display "  ... wellformedness test succeeeded.".
           Display Space.
           Display "XML VALIDATE FILE - well-formed - invalid ...".

           XML VALIDATE FILE
               "x-addressa2"      *> document to validate file name (input)
               "examplea".        *> XML Schema document for validation (input)
           If Not XML-OK
               Perform Display-Status
               Display "  ... validation failed (as it should)."
           Else
               Display "  ... validation succeeded (error)!"
           End-If.

           Display Space.                                               TESTS
           Display "Press a key to continue:".                          TESTS
           Accept Done.                                                 TESTS
           Display Space.
           Display "XML TEST WELLFORMED-FILE - well-formed - valid ...".

           XML TEST WELLFORMED-FILE
               "x-addressa3".     *> document to test file name (input)
           If Not XML-OK Go to Z End-If.

           Display "  ... wellformedness test succeeeded.".
           Display Space.
           Display "XML VALIDATE FILE - well-formed - valid ...".

           XML VALIDATE FILE
               "x-addressa3"      *> document to validate file name (input)
               "examplea".        *> XML Schema document for validation (input)
           If Not XML-OK Go to Z End-If.

           Display "  ... validation successful.".
           Display Space.

       Z.
           Copy "lixmltrm.cpy".

           Display "Press a key to terminate:".                         TESTS
           Accept Done.                                                 TESTS
           Stop Run.

           Copy "lixmldsp.cpy".

       End Program  Example-A.
