@echo off
set INVDB=0
set BADDB=master sybsystemprocs temp model
if not "%OS%" == "Windows_NT" goto NeedNT
echo.
if "%1" == "" goto usage
mkdir xtmpx
for %%f in (%BADDB%) do echo yes > xtmpx\%%f
if exist xtmpx\%1 set INVDB=1
for %%f in (%BADDB%) do del xtmpx\%%f
rmdir xtmpx
if %INVDB%==0 goto doit

:NeedNT
echo This file requires Windows NT or Windows 2000 to run.
goto end

:usage
echo You must enter the name of a database to hold the various lock tables.
echo If the database name you give does not exist, it will be created.
echo The invalid database names are "%BADDB%".
echo.
echo For example, "%0 mydb"
goto end

:doit
if exist syb_inst.sql del syb_inst.sql
echo use master >> syb_inst.sql
echo go >> syb_inst.sql
echo if exists (select name from sysdatabases where name = 'sybsystemprocs') >> syb_inst.sql
echo 	use sybsystemprocs >> syb_inst.sql
echo go >> syb_inst.sql
echo if exists (select * from sysobjects where >> syb_inst.sql
echo 		name = 'sp_AcuCheckTable_2' and type = 'P') >> syb_inst.sql
echo begin >> syb_inst.sql
echo 	print 'Dropping sp_AcuCheckTable_2' >> syb_inst.sql
echo 	drop procedure sp_AcuCheckTable_2 >> syb_inst.sql
echo end >> syb_inst.sql
echo go >> syb_inst.sql
echo create procedure sp_AcuCheckTable_2 >> syb_inst.sql
echo @db varchar(128) = NULL, >> syb_inst.sql
echo @user varchar(128) = NULL, >> syb_inst.sql
echo @tab varchar(128) = NULL, >> syb_inst.sql
echo @objid int output >> syb_inst.sql
echo as >> syb_inst.sql
echo 	declare @type int >> syb_inst.sql
echo 	if (@tab is NULL) >> syb_inst.sql
echo 	begin >> syb_inst.sql
echo 		raiserror ('No table name given', 0, 1) >> syb_inst.sql
echo 		return 1 >> syb_inst.sql
echo 	end >> syb_inst.sql
echo 	if (@db is not NULL and @db != db_name ()) >> syb_inst.sql
echo 	begin >> syb_inst.sql
echo 		raiserror ('Table must be in current database', 0, 2) >> syb_inst.sql
echo 		return 1 >> syb_inst.sql
echo 	end >> syb_inst.sql
echo 	if (@user = NULL or @user = '') >> syb_inst.sql
echo 		select @objid = id, @type = (sysstat ^& 7) from >> syb_inst.sql
echo 				sysobjects where name = @tab and >> syb_inst.sql
echo 				type in ('S', 'U', 'V') >> syb_inst.sql
echo 	else >> syb_inst.sql
echo 		select @objid = o.id, @type = (o.sysstat ^& 7) from >> syb_inst.sql
echo 				sysobjects o, sysusers u where >> syb_inst.sql
echo 			o.name = @tab and o.uid = u.uid and >> syb_inst.sql
echo 			u.name = @user and o.type in ('S', 'U', 'V') >> syb_inst.sql
echo 	if (@objid = NULL or @objid = 0 or @type not in (1, 2, 3)) >> syb_inst.sql
echo 	begin >> syb_inst.sql
echo 		raiserror ('Table does not exist', 0, 3) >> syb_inst.sql
echo 		return 1 >> syb_inst.sql
echo 	end >> syb_inst.sql
echo 	return 0 >> syb_inst.sql
echo go >> syb_inst.sql
echo grant execute on sp_AcuCheckTable_2 to public >> syb_inst.sql
echo go >> syb_inst.sql
echo print 'sp_AcuCheckTable_2 installed' >> syb_inst.sql
echo go >> syb_inst.sql
echo if exists (select * from sysobjects where >> syb_inst.sql
echo 		name = 'sp_AcuDescribe_2' and type = 'P') >> syb_inst.sql
echo begin >> syb_inst.sql
echo 	print 'Dropping sp_AcuDescribe_2' >> syb_inst.sql
echo 	drop procedure sp_AcuDescribe_2 >> syb_inst.sql
echo end >> syb_inst.sql
echo go >> syb_inst.sql
echo create procedure sp_AcuDescribe_2 >> syb_inst.sql
echo @objid int >> syb_inst.sql
echo as >> syb_inst.sql
echo 	select name, usertype, type, length, status from syscolumns where >> syb_inst.sql
echo 		id = @objid >> syb_inst.sql
echo 	return 0 >> syb_inst.sql
echo go >> syb_inst.sql
echo grant execute on sp_AcuDescribe_2 to public >> syb_inst.sql
echo go >> syb_inst.sql
echo print 'sp_AcuDescribe_2 installed' >> syb_inst.sql
echo go >> syb_inst.sql
echo if exists (select * from sysobjects where >> syb_inst.sql
echo 		name = 'sp_AcuFindUnique_3' and type = 'P') >> syb_inst.sql
echo begin >> syb_inst.sql
echo 	print 'Dropping sp_AcuFindUnique_3' >> syb_inst.sql
echo 	drop procedure sp_AcuFindUnique_3 >> syb_inst.sql
echo end >> syb_inst.sql
echo go >> syb_inst.sql
echo create procedure sp_AcuFindUnique_3  >> syb_inst.sql
echo @tablename char(128) = NULL,  >> syb_inst.sql
echo @objid int  >> syb_inst.sql
echo as  >> syb_inst.sql
echo 	declare @tab varchar(128) >> syb_inst.sql
echo 	if (@tablename = NULL) >> syb_inst.sql
echo 	begin >> syb_inst.sql
echo 		declare @user varchar(128) >> syb_inst.sql
echo 		declare @obj varchar(128) >> syb_inst.sql
echo 		select @user = u.name, @obj = o.name from >> syb_inst.sql
echo 			sysusers u, sysobjects o where >> syb_inst.sql
echo 			o.id = @objid and u.uid = o.uid >> syb_inst.sql
echo 		select @tab = rtrim(@user) + '.' + rtrim(@obj) >> syb_inst.sql
echo 	end >> syb_inst.sql
echo 	else >> syb_inst.sql
echo 	begin >> syb_inst.sql
echo 		select @tab = @tablename >> syb_inst.sql
echo 	end >> syb_inst.sql
echo 	select name, indid, status,  >> syb_inst.sql
echo 		index_col (@tab, indid, 1), index_col (@tab, indid, 2),  >> syb_inst.sql
echo 		index_col (@tab, indid, 3), index_col (@tab, indid, 4),  >> syb_inst.sql
echo 		index_col (@tab, indid, 5), index_col (@tab, indid, 6),  >> syb_inst.sql
echo 		index_col (@tab, indid, 7), index_col (@tab, indid, 8),  >> syb_inst.sql
echo 		index_col (@tab, indid, 9), index_col (@tab, indid, 10),  >> syb_inst.sql
echo 		index_col (@tab, indid, 11), index_col (@tab, indid, 12),  >> syb_inst.sql
echo 		index_col (@tab, indid, 13), index_col (@tab, indid, 14),  >> syb_inst.sql
echo 		index_col (@tab, indid, 15), index_col (@tab, indid, 16)  >> syb_inst.sql
echo 			from sysindexes where id = @objid  >> syb_inst.sql
echo 	return 0  >> syb_inst.sql
echo go  >> syb_inst.sql
echo grant execute on sp_AcuFindUnique_3 to public >> syb_inst.sql
echo go >> syb_inst.sql
echo print 'sp_AcuFindUnique_3 installed' >> syb_inst.sql
echo go >> syb_inst.sql
echo if exists (select * from sysobjects where >> syb_inst.sql
echo 		name = 'sp_AcuGetUser_1' and type = 'P') >> syb_inst.sql
echo begin >> syb_inst.sql
echo 	print 'Dropping sp_AcuGetUser_1' >> syb_inst.sql
echo 	drop procedure sp_AcuGetUser_1 >> syb_inst.sql
echo end >> syb_inst.sql
echo go >> syb_inst.sql
echo create procedure sp_AcuGetUser_1 >> syb_inst.sql
echo @objid int = NULL, >> syb_inst.sql
echo @user varchar (30) output >> syb_inst.sql
echo as >> syb_inst.sql
echo 	select @user = u.name from sysusers u, sysobjects o where >> syb_inst.sql
echo 		o.id = @objid and o.uid = u.uid >> syb_inst.sql
echo go >> syb_inst.sql
echo grant execute on sp_AcuGetUser_1 to public >> syb_inst.sql
echo go >> syb_inst.sql
echo print 'sp_AcuGetUser_1 installed' >> syb_inst.sql
echo go >> syb_inst.sql
echo if exists (select * from sysobjects where >> syb_inst.sql
echo 		name = 'sp_AcuCountTables_1' and type = 'P') >> syb_inst.sql
echo begin >> syb_inst.sql
echo 	print 'Dropping sp_AcuCountTables_1' >> syb_inst.sql
echo 	drop procedure sp_AcuCountTables_1 >> syb_inst.sql
echo end >> syb_inst.sql
echo go >> syb_inst.sql
echo create procedure sp_AcuCountTables_1 >> syb_inst.sql
echo @objid int = NULL >> syb_inst.sql
echo as >> syb_inst.sql
echo 	declare @uid int >> syb_inst.sql
echo 	declare @name char(30) >> syb_inst.sql
echo 	declare @likename char(35) >> syb_inst.sql
echo 	if (@objid = NULL) >> syb_inst.sql
echo 	begin >> syb_inst.sql
echo 		raiserror ('No table id given', 0, 1) >> syb_inst.sql
echo 		return 1 >> syb_inst.sql
echo 	end >> syb_inst.sql
echo 	select @uid = uid, @name = name from sysobjects where id = @objid >> syb_inst.sql
echo 	if (@uid = NULL) >> syb_inst.sql
echo 	begin >> syb_inst.sql
echo 		raiserror ('Bad object id given', 0, 1) >> syb_inst.sql
echo 		return 1 >> syb_inst.sql
echo 	end >> syb_inst.sql
echo 	select @likename = rtrim(@name) + 'A' >> syb_inst.sql
echo 	if (select count(*) from sysobjects where >> syb_inst.sql
echo 		name like rtrim(@likename) and uid = @uid) = 0 >> syb_inst.sql
echo 		select 0 >> syb_inst.sql
echo 	else >> syb_inst.sql
echo 	begin >> syb_inst.sql
echo 		select @likename = rtrim(@name) + '[A-Z]' >> syb_inst.sql
echo 		select count(*) from sysobjects where >> syb_inst.sql
echo 			name like rtrim(@likename) and uid = @uid >> syb_inst.sql
echo 	end >> syb_inst.sql
echo go >> syb_inst.sql
echo grant execute on sp_AcuCountTables_1 to public >> syb_inst.sql
echo go >> syb_inst.sql
echo print 'sp_AcuCountTables_1 installed' >> syb_inst.sql
echo go >> syb_inst.sql
echo use master >> syb_inst.sql
echo go >> syb_inst.sql
echo if not exists (select name from sysdatabases where name = '%1') >> syb_inst.sql
echo begin >> syb_inst.sql
echo 	print 'Creating database %1' >> syb_inst.sql
echo 	create database %1 >> syb_inst.sql
echo end >> syb_inst.sql
echo go >> syb_inst.sql
echo use %1 >> syb_inst.sql
echo go >> syb_inst.sql
echo if exists (select * from sysobjects where >> syb_inst.sql
echo 		name = 'AcuLocks1' and type = 'U') >> syb_inst.sql
echo begin >> syb_inst.sql
echo 	print 'Dropping AcuLocks1' >> syb_inst.sql
echo 	drop table AcuLocks1 >> syb_inst.sql
echo end >> syb_inst.sql
echo go >> syb_inst.sql
echo create table AcuLocks1 (DBID int default -1, TableNum int default 0, >> syb_inst.sql
echo 		         TableID int, LockPID int, KeyValue varbinary(250)) >> syb_inst.sql
echo go >> syb_inst.sql
echo create unique nonclustered index AcuLocks1Primary on AcuLocks1 (DBID, TableID, KeyValue) >> syb_inst.sql
echo go >> syb_inst.sql
echo create nonclustered index AcuLocks1Secondary on AcuLocks1 (DBID, TableID, TableNum, LockPID, KeyValue) >> syb_inst.sql
echo go >> syb_inst.sql
echo create nonclustered index AcuLocks1LockPID on AcuLocks1 (LockPID) >> syb_inst.sql
echo go >> syb_inst.sql
echo grant all on AcuLocks1 to public >> syb_inst.sql
echo go >> syb_inst.sql
echo print 'AcuLocks1 created' >> syb_inst.sql
echo go >> syb_inst.sql
echo if exists (select * from sysobjects where >> syb_inst.sql
echo 		name = 'AcuLocks1Trigger' and type = 'TR') >> syb_inst.sql
echo begin >> syb_inst.sql
echo 	print 'Dropping AcuLocks1Trigger' >> syb_inst.sql
echo 	drop trigger AcuLocks1Trigger >> syb_inst.sql
echo end >> syb_inst.sql
echo go >> syb_inst.sql
echo if exists (select * from sysobjects where >> syb_inst.sql
echo 		name = 'AcuOpenTables1' and type = 'U') >> syb_inst.sql
echo begin >> syb_inst.sql
echo 	print 'Dropping AcuOpenTables1' >> syb_inst.sql
echo 	drop table AcuOpenTables1 >> syb_inst.sql
echo end >> syb_inst.sql
echo go >> syb_inst.sql
echo create table AcuOpenTables1 (DBID int default -1, TableNum int default 0, >> syb_inst.sql
echo 			     TableID int, OpenPID int, >> syb_inst.sql
echo 			     OpenMode tinyint, MultiLock bit, ReadLock bit, >> syb_inst.sql
echo 			     WriteLock bit, MassUpdate bit) >> syb_inst.sql
echo go >> syb_inst.sql
echo create nonclustered index AcuOpenTables1Mass on AcuOpenTables1 (DBID, TableID, MassUpdate) >> syb_inst.sql
echo go >> syb_inst.sql
echo create nonclustered index AcuOpenTables1Multi on AcuOpenTables1 (DBID, TableID, MultiLock) >> syb_inst.sql
echo go >> syb_inst.sql
echo create nonclustered index AcuOpenTables1Primary on AcuOpenTables1 (DBID, TableID) >> syb_inst.sql
echo go >> syb_inst.sql
echo create nonclustered index AcuOpenTables1Read on AcuOpenTables1 (DBID, TableID, ReadLock) >> syb_inst.sql
echo go >> syb_inst.sql
echo create nonclustered index AcuOpenTables1Write on AcuOpenTables1 (DBID, TableID, WriteLock) >> syb_inst.sql
echo go >> syb_inst.sql
echo create nonclustered index AcuOpenTables1OpenPID on AcuOpenTables1 (OpenPID) >> syb_inst.sql
echo go >> syb_inst.sql
echo grant all on AcuOpenTables1 to public >> syb_inst.sql
echo go >> syb_inst.sql
echo print 'AcuOpenTables1 created' >> syb_inst.sql
echo go >> syb_inst.sql
echo if exists (select * from sysobjects where >> syb_inst.sql
echo 		name = 'AcuOpenTable1Trigger' and type = 'TR') >> syb_inst.sql
echo begin >> syb_inst.sql
echo 	print 'Dropping AcuOpenTable1Trigger' >> syb_inst.sql
echo 	drop trigger AcuOpenTable1Trigger >> syb_inst.sql
echo end >> syb_inst.sql
echo go >> syb_inst.sql
echo create trigger AcuOpenTable1Trigger on AcuOpenTables1 for insert >> syb_inst.sql
echo as >> syb_inst.sql
echo 	declare	@cnt	int >> syb_inst.sql
echo 	if (select WriteLock from inserted) = 1 >> syb_inst.sql
echo 	begin >> syb_inst.sql
echo 		if (select count(*) from AcuOpenTables1, inserted where >> syb_inst.sql
echo 			AcuOpenTables1.DBID = inserted.DBID and >> syb_inst.sql
echo 			AcuOpenTables1.TableID = inserted.TableID) ^> 1 >> syb_inst.sql
echo 		begin >> syb_inst.sql
echo 			raiserror ('Table is open by another user', 0, 4) >> syb_inst.sql
echo 			rollback transaction >> syb_inst.sql
echo 		end >> syb_inst.sql
echo 	end >> syb_inst.sql
echo 	else >> syb_inst.sql
echo 	begin >> syb_inst.sql
echo 		if exists (select * from AcuOpenTables1, inserted where >> syb_inst.sql
echo 			AcuOpenTables1.DBID = inserted.DBID and >> syb_inst.sql
echo 			AcuOpenTables1.TableID = inserted.TableID and >> syb_inst.sql
echo 			AcuOpenTables1.WriteLock = 1) >> syb_inst.sql
echo 		begin >> syb_inst.sql
echo 			raiserror ('Table is write-locked by another user', 0, 4) >> syb_inst.sql
echo 			rollback transaction >> syb_inst.sql
echo 		end >> syb_inst.sql
echo 	end >> syb_inst.sql
echo 	if (select ReadLock from inserted) = 1 >> syb_inst.sql
echo 	begin >> syb_inst.sql
echo 		if (select OpenMode from inserted) != 0 >> syb_inst.sql
echo 			select @cnt = 1 >> syb_inst.sql
echo 		else >> syb_inst.sql
echo 			select @cnt = 0 >> syb_inst.sql
echo 		if (select count(*) from AcuOpenTables1, inserted where >> syb_inst.sql
echo 			AcuOpenTables1.DBID = inserted.DBID and >> syb_inst.sql
echo 			AcuOpenTables1.TableID = inserted.TableID and >> syb_inst.sql
echo 			AcuOpenTables1.OpenMode != 0) ^> @cnt >> syb_inst.sql
echo 		begin >> syb_inst.sql
echo 			raiserror ('Table is open by another user', 0, 4) >> syb_inst.sql
echo 			rollback transaction >> syb_inst.sql
echo 		end >> syb_inst.sql
echo 	end >> syb_inst.sql
echo 	else >> syb_inst.sql
echo 	begin >> syb_inst.sql
echo 		if (select OpenMode from inserted) != 0 >> syb_inst.sql
echo 		begin >> syb_inst.sql
echo 			if exists (select * from AcuOpenTables1, inserted where >> syb_inst.sql
echo 				AcuOpenTables1.DBID = inserted.DBID and >> syb_inst.sql
echo 				AcuOpenTables1.TableID = inserted.TableID and >> syb_inst.sql
echo 				AcuOpenTables1.ReadLock = 1) >> syb_inst.sql
echo 			begin >> syb_inst.sql
echo 				raiserror ('Table is read-locked by another user',0, 4) >> syb_inst.sql
echo 				rollback transaction >> syb_inst.sql
echo 			end >> syb_inst.sql
echo 		end >> syb_inst.sql
echo 	end >> syb_inst.sql
echo go >> syb_inst.sql
echo print 'AcuOpenTable1Trigger created' >> syb_inst.sql
echo go >> syb_inst.sql
echo if exists (select * from sysobjects where >> syb_inst.sql
echo 		name = 'sp_AcuUserCount3' and type = 'P') >> syb_inst.sql
echo begin >> syb_inst.sql
echo 	print 'Dropping sp_AcuUserCount3' >> syb_inst.sql
echo 	drop procedure sp_AcuUserCount3 >> syb_inst.sql
echo end >> syb_inst.sql
echo go >> syb_inst.sql
echo create procedure sp_AcuUserCount3 >> syb_inst.sql
echo @db varchar(128) = NULL, >> syb_inst.sql
echo @user varchar(128) = NULL, >> syb_inst.sql
echo @tab varchar(128) = NULL >> syb_inst.sql
echo as >> syb_inst.sql
echo 	declare @objid int >> syb_inst.sql
echo 	declare @returncode int >> syb_inst.sql
echo 	declare @cnt int >> syb_inst.sql
echo 	declare @dbid int >> syb_inst.sql
echo 	declare @message varchar (255) >> syb_inst.sql
echo 	execute @returncode = sp_AcuCheckTable_2 @db, @user, @tab, @objid output >> syb_inst.sql
echo 	if @returncode != 0 >> syb_inst.sql
echo 		return @returncode >> syb_inst.sql
echo 	select @dbid = dbid from master..sysdatabases where name = db_name() >> syb_inst.sql
echo 	select @cnt = count(*) from AcuOpenTables1 >> syb_inst.sql
echo 			where DBID = @dbid and TableID = @objid >> syb_inst.sql
echo 	if @cnt = 0 >> syb_inst.sql
echo 		select @message = 'Table ''' + @tab + >> syb_inst.sql
echo 			''' is not open by any users.' >> syb_inst.sql
echo 	else >> syb_inst.sql
echo 		select @message = 'Table ''' + @tab + ''' is open by ' + >> syb_inst.sql
echo 			convert (varchar (30), @cnt) + ' user(s).' >> syb_inst.sql
echo 	print @message >> syb_inst.sql
echo go >> syb_inst.sql
echo grant execute on sp_AcuUserCount3 to public >> syb_inst.sql
echo go >> syb_inst.sql
echo print 'sp_AcuUserCount3 installed' >> syb_inst.sql
echo go >> syb_inst.sql
echo if exists (select * from sysobjects where >> syb_inst.sql
echo 		name = 'sp_AcuZeroUserCount3' and type = 'P') >> syb_inst.sql
echo begin >> syb_inst.sql
echo 	print 'Dropping sp_AcuZeroUserCount3' >> syb_inst.sql
echo 	drop procedure sp_AcuZeroUserCount3 >> syb_inst.sql
echo end >> syb_inst.sql
echo go >> syb_inst.sql
echo create procedure sp_AcuZeroUserCount3 >> syb_inst.sql
echo @db varchar(128) = NULL, >> syb_inst.sql
echo @user varchar(128) = NULL, >> syb_inst.sql
echo @tab varchar(128) = NULL >> syb_inst.sql
echo as >> syb_inst.sql
echo 	declare @objid int >> syb_inst.sql
echo 	declare @returncode int >> syb_inst.sql
echo 	declare @dbid int >> syb_inst.sql
echo 	execute @returncode = sp_AcuCheckTable_2 @db, @user, @tab, @objid output >> syb_inst.sql
echo 	if @returncode != 0 >> syb_inst.sql
echo 		return @returncode >> syb_inst.sql
echo 	select @dbid = dbid from master..sysdatabases where name = db_name() >> syb_inst.sql
echo 	delete from AcuOpenTables1 where DBID = @dbid and TableID = @objid >> syb_inst.sql
echo 	delete from AcuLocks1 where DBID = @dbid and TableID = @objid >> syb_inst.sql
echo go >> syb_inst.sql
echo grant execute on sp_AcuZeroUserCount3 to public >> syb_inst.sql
echo go >> syb_inst.sql
echo print 'sp_AcuZeroUserCount3 installed' >> syb_inst.sql
echo go >> syb_inst.sql
echo if exists (select * from sysobjects where >> syb_inst.sql
echo 		name = 'sp_AcuTableReport3' and type = 'P') >> syb_inst.sql
echo begin >> syb_inst.sql
echo 	print 'Dropping sp_AcuTableReport3' >> syb_inst.sql
echo 	drop procedure sp_AcuTableReport3 >> syb_inst.sql
echo end >> syb_inst.sql
echo go >> syb_inst.sql
echo create procedure sp_AcuTableReport3 >> syb_inst.sql
echo @db varchar(128) = NULL, >> syb_inst.sql
echo @user varchar(128) = NULL, >> syb_inst.sql
echo @tab varchar(128) = NULL >> syb_inst.sql
echo as >> syb_inst.sql
echo 	declare @objid int >> syb_inst.sql
echo 	declare @returncode int >> syb_inst.sql
echo 	declare @dbid int >> syb_inst.sql
echo 	execute @returncode = sp_AcuCheckTable_2 @db, @user, @tab, @objid output >> syb_inst.sql
echo 	if @returncode != 0 >> syb_inst.sql
echo 		return @returncode >> syb_inst.sql
echo 	select @dbid = dbid from master..sysdatabases where name = db_name() >> syb_inst.sql
echo 	select * from AcuOpenTables1 where DBID = @dbid and TableID = @objid >> syb_inst.sql
echo 	select * from AcuLocks1 where DBID = @dbid and TableID = @objid >> syb_inst.sql
echo go >> syb_inst.sql
echo grant execute on sp_AcuTableReport3 to public >> syb_inst.sql
echo go >> syb_inst.sql
echo print 'sp_AcuTableReport3 installed' >> syb_inst.sql
echo go >> syb_inst.sql
echo if exists (select * from sysobjects where >> syb_inst.sql
echo 		name = 'sp_AcuRemoveUnusedLocks_1' and type = 'P') >> syb_inst.sql
echo begin >> syb_inst.sql
echo 	print 'Dropping sp_AcuRemoveUnusedLocks_1' >> syb_inst.sql
echo 	drop procedure sp_AcuRemoveUnusedLocks_1 >> syb_inst.sql
echo end >> syb_inst.sql
echo go >> syb_inst.sql
echo create procedure sp_AcuRemoveUnusedLocks_1 >> syb_inst.sql
echo as >> syb_inst.sql
echo 	delete from AcuLocks1 where LockPID not in >> syb_inst.sql
echo 		(select spid from master..sysprocesses) >> syb_inst.sql
echo 	delete from AcuLocks1 where LockPID = @@spid >> syb_inst.sql
echo 	delete from AcuOpenTables1 where OpenPID not in >> syb_inst.sql
echo 		(select spid from master..sysprocesses) >> syb_inst.sql
echo 	delete from AcuOpenTables1 where OpenPID = @@spid >> syb_inst.sql
echo go >> syb_inst.sql
echo grant execute on sp_AcuRemoveUnusedLocks_1 to public >> syb_inst.sql
echo go >> syb_inst.sql
echo print 'sp_AcuRemoveUnusedLocks_1 installed' >> syb_inst.sql
echo go >> syb_inst.sql
echo if exists (select * from sysobjects where >> syb_inst.sql
echo 		name = 'sp_AcuLockRec3' and type = 'P') >> syb_inst.sql
echo begin >> syb_inst.sql
echo 	print 'Dropping sp_AcuLockRec3' >> syb_inst.sql
echo 	drop procedure sp_AcuLockRec3 >> syb_inst.sql
echo end >> syb_inst.sql
echo go >> syb_inst.sql
echo create procedure sp_AcuLockRec3 >> syb_inst.sql
echo @dbid int, >> syb_inst.sql
echo @tablenum int, >> syb_inst.sql
echo @objid int, >> syb_inst.sql
echo @procid int, >> syb_inst.sql
echo @keyval varbinary(250), >> syb_inst.sql
echo @tranlevel smallint = 0 >> syb_inst.sql
echo as >> syb_inst.sql
echo 	if (select count(*) from AcuLocks1 where >> syb_inst.sql
echo 		DBID = @dbid and >> syb_inst.sql
echo 		TableNum = @tablenum and >> syb_inst.sql
echo 		TableID = @objid and >> syb_inst.sql
echo 		LockPID = @procid and >> syb_inst.sql
echo 		KeyValue = @keyval) = 0 >> syb_inst.sql
echo 	begin >> syb_inst.sql
echo 		if (@tranlevel = 0 and >> syb_inst.sql
echo 		    (select MultiLock from AcuOpenTables1 where >> syb_inst.sql
echo 			DBID = @dbid and >> syb_inst.sql
echo 			TableNum = @tablenum and >> syb_inst.sql
echo 			TableID = @objid and >> syb_inst.sql
echo 			OpenPID = @procid) = 0) >> syb_inst.sql
echo 		begin >> syb_inst.sql
echo 			delete from AcuLocks1 where >> syb_inst.sql
echo 				DBID = @dbid and >> syb_inst.sql
echo 				TableNum = @tablenum and >> syb_inst.sql
echo 				TableID = @objid and >> syb_inst.sql
echo 				LockPID = @procid and >> syb_inst.sql
echo 				KeyValue != @keyval >> syb_inst.sql
echo 		end >> syb_inst.sql
echo 		insert into AcuLocks1 (DBID, TableNum, TableID, LockPID, KeyValue) values >> syb_inst.sql
echo 			(@dbid, @tablenum, @objid, @procid, @keyval) >> syb_inst.sql
echo 	end >> syb_inst.sql
echo go >> syb_inst.sql
echo grant execute on sp_AcuLockRec3 to public >> syb_inst.sql
echo go >> syb_inst.sql
echo print 'sp_AcuLockRec3 installed' >> syb_inst.sql
echo go >> syb_inst.sql
echo if exists (select * from sysobjects where >> syb_inst.sql
echo 		name = 'sp_AcuUnlockOneRec3' and type = 'P') >> syb_inst.sql
echo begin >> syb_inst.sql
echo 	print 'Dropping sp_AcuUnlockOneRec3' >> syb_inst.sql
echo 	drop procedure sp_AcuUnlockOneRec3 >> syb_inst.sql
echo end >> syb_inst.sql
echo go >> syb_inst.sql
echo create procedure sp_AcuUnlockOneRec3 >> syb_inst.sql
echo @dbid int, >> syb_inst.sql
echo @tablenum int, >> syb_inst.sql
echo @objid int, >> syb_inst.sql
echo @procid int, >> syb_inst.sql
echo @keyval varbinary(250) >> syb_inst.sql
echo as >> syb_inst.sql
echo 	delete from AcuLocks1 where >> syb_inst.sql
echo 		DBID = @dbid and >> syb_inst.sql
echo 		TableNum = @tablenum and >> syb_inst.sql
echo 		TableID = @objid and >> syb_inst.sql
echo 		LockPID = @procid and >> syb_inst.sql
echo 		KeyValue = @keyval >> syb_inst.sql
echo go >> syb_inst.sql
echo grant execute on sp_AcuUnlockOneRec3 to public >> syb_inst.sql
echo go >> syb_inst.sql
echo print 'sp_AcuUnlockOneRec3 installed' >> syb_inst.sql
echo go >> syb_inst.sql
echo if exists (select * from sysobjects where >> syb_inst.sql
echo 		name = 'sp_AcuUnlockAllFileRecs2' and type = 'P') >> syb_inst.sql
echo begin >> syb_inst.sql
echo 	print 'Dropping sp_AcuUnlockAllFileRecs2' >> syb_inst.sql
echo 	drop procedure sp_AcuUnlockAllFileRecs2 >> syb_inst.sql
echo end >> syb_inst.sql
echo go >> syb_inst.sql
echo create procedure sp_AcuUnlockAllFileRecs2 >> syb_inst.sql
echo @dbid int, >> syb_inst.sql
echo @tablenum int, >> syb_inst.sql
echo @objid int, >> syb_inst.sql
echo @procid	int >> syb_inst.sql
echo as >> syb_inst.sql
echo 	delete from AcuLocks1 where >> syb_inst.sql
echo 		DBID = @dbid and >> syb_inst.sql
echo 		TableNum = @tablenum and >> syb_inst.sql
echo 		TableID = @objid and >> syb_inst.sql
echo 		LockPID = @procid >> syb_inst.sql
echo go >> syb_inst.sql
echo grant execute on sp_AcuUnlockAllFileRecs2 to public >> syb_inst.sql
echo go >> syb_inst.sql
echo print 'sp_AcuUnlockAllFileRecs2 installed' >> syb_inst.sql
echo go >> syb_inst.sql
echo if exists (select * from sysobjects where >> syb_inst.sql
echo 		name = 'sp_AcuUnlockAllRecs_2' and type = 'P') >> syb_inst.sql
echo begin >> syb_inst.sql
echo 	print 'Dropping sp_AcuUnlockAllRecs_2' >> syb_inst.sql
echo 	drop procedure sp_AcuUnlockAllRecs_2 >> syb_inst.sql
echo end >> syb_inst.sql
echo go >> syb_inst.sql
echo create procedure sp_AcuUnlockAllRecs_2 >> syb_inst.sql
echo @procid	int >> syb_inst.sql
echo as >> syb_inst.sql
echo 	delete from AcuLocks1 where >> syb_inst.sql
echo 		LockPID = @procid >> syb_inst.sql
echo go >> syb_inst.sql
echo grant execute on sp_AcuUnlockAllRecs_2 to public >> syb_inst.sql
echo go >> syb_inst.sql
echo print 'sp_AcuUnlockAllRecs_2 installed' >> syb_inst.sql
echo go >> syb_inst.sql
echo exit_script: >> syb_inst.sql

echo syb_inst.sql created

:end
set BADDB=
set INVDB=
